import java.awt.Color;
import javax.swing.*;
import java.util.concurrent.*;

public class Balls {

    public static void nap(int ms) {
	try {
	    Thread.sleep(ms);
	}
	catch(InterruptedException e) {
	    //
	    //  Print out the name of the tread that caused this.
	    //
	    System.err.println("Thread "+Thread.currentThread().getName()+
			       " throwed exception "+e.getMessage());
	}
    }

    public static void main(String[] a) {
	
        final BallWorld world = new BallWorld();
	final JFrame win = new JFrame();
	SwingUtilities.invokeLater(new Runnable() {
	    public void run() {
		win.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		win.getContentPane().add(world);
		win.pack();
		win.setVisible(true);
	    }});
	
	Thread.currentThread().setName("MyMainThread");

	final Semaphore done = new Semaphore(0);
	final Semaphore go[] = new Semaphore[4];
	for(int x=0;x<4;x++)
	    go[x] = new Semaphore(0);

	nap((int)(5000*Math.random()));
	new Ball(world, 50, 80, 5, 10, Color.red, done, go[0]).start();
	nap((int)(5000*Math.random()));
	new Ball(world, 70, 100, 8, 6, Color.blue, done, go[1]).start();
	nap((int)(5000*Math.random()));
	new Ball(world, 150, 100, 9, 7, Color.green, done, go[2]).start();
	nap((int)(5000*Math.random()));
	new Ball(world, 200, 130, 3, 8, Color.black, done, go[3]).start();
	nap((int)(5000*Math.random()));

	(new Thread("Coordinator") {
		public void run() {
		    try {
			while (true) {
			    int x;
			    for(x=0;x<4;x++)
				done.acquire();
			    for(x=0;x<4;x++)
				go[x].release();
			}
		    }
		    catch (InterruptedException e) {
		    }
		}
	    }).start();
    }
}
